
#include <ncurses.h>
#include <sys/ioctl.h>
#include <stddef.h>
#include <linux/kd.h>
#include <signal.h>

#define KEY_ESC 27
#define KEY_TAB 9
#define W 256     /* text buffer width */ 
#define BUF 8192  /* text buffer lines */ 
#define BLK 1024  /* block buffer lines */ 
#define Y 23      /* init max curs lines */ 
#define X 79      /* init max curs col's */ 

extern WINDOW *win;

extern int txt[BUF][W], c,
	curr_line,
	curr_pos, 
	TAB_VAL,
	tit_flg,
	comfirm_flg,
	ym,xm,
	utf_8, // flag if LANG is UTF-8 Based
	utf8_valid,
	current_color,
	del_blk_flg,
	blk_flg,
	chr, y_max, x_max,
	xshift,          /* current x shift in buffer for display purpose */  
    last_xshift,
    last_inst_x,last_inst_y, /* last place we were typing */
	curs_x, curs_y;
	
int eof_line(); //&eof_line
void bip(); //&bip
void reloc(); //&reloc
void displ_line(); //&displ_line
void put_cur_pos(); //&put_cur_pos
void tut(); //&tut
void color(int color); //&color
void quit(); //&quit
void init(); //&init
void bip(); //&bip
void tit(); //&tit
void tut(); //&tut
void titat(); //&titat
void tatit(); //&tatit
void titatut(); //&titatut
void put_blk_status(); 
void put_line_num(); 

