/***********************************************************************
* 						String Completion
************************************************************************/

//#include "pe.h"
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <ncurses.h>

#define KEY_TAB 9

extern int utf_8, y_max;
extern char file_name[256], curr_dir[128];;
  /* file name buffer */
char str[128], dir_sel[128];


//GCompletion *gcmpl=NULL;


int is_this_file(char *path) /* returns 0 if file exists !! */
{
struct stat buf;
int i;

i=stat(path,&buf);
if (i==0){
	if (S_ISDIR(buf.st_mode)>0)return(1);
	else return(0);
   };
return(1);
}

int is_this_dir(char* path) /* returns 0 if dir exists !! */
{
struct stat buf;
int i;
i=stat(path,&buf);
if (i==0){
   if (S_ISDIR(buf.st_mode)>0)return(0);
   };
return(1);
}

void rfrsh_cmd(char *str)
{
int start;
cll();
start=0;
loc( y_max+1,1);
if (strlen(str)>70)start =	(strlen(str)-70);
printw("%s%s",gettext("File:"),&str[start]);
}


int try_cmplt(char* from, char *with)
{
struct dirent *ep;
DIR *dp;
return(0);

/*GList *result;
//gchar *new_pfx;
//g_completion_clear_items(gcmpl);
// populate
if (gcmpl==NULL) gcmpl=g_completion_new(NULL);
g_list_free(items);
items = NULL;
dp = opendir (from);
if (dp != NULL){
	int i=0;
  while ((ep = readdir(dp))!=NULL){
		items=g_list_append (items, (gpointer)ep->d_name);
		i++;
		};
  (void)closedir(dp);
	g_completion_add_items(gcmpl, items);
	result=g_completion_complete (gcmpl, with, &new_pfx);
	if (result!=NULL){
		if (new_pfx!=NULL){
			if (strcmp(str,new_pfx)!=0){
				if (strlen(new_pfx)<127)strcpy(str, new_pfx);
				g_free(new_pfx);
				g_completion_clear_items(gcmpl);
				return(1);
				}
			else{
				g_free(new_pfx);
				g_completion_clear_items(gcmpl);
				return(2);
				};
			};
		};
  };
g_completion_clear_items(gcmpl);
return(0);
*/
}


void get_fname(int req){

char lfile_name[256],c;
unsigned int ch, l;
int r;
echo();
if (req==0){
	/* where are we? */
	if ((getcwd(dir_sel, 126)!=NULL)&&(curr_dir[0]==0)){
		if(is_this_dir(dir_sel)==0)
			strcpy(curr_dir, dir_sel);
		/* add a '/' */
		strcat(curr_dir, "/");
		};
	rfrsh_cmd(curr_dir);
	strcpy(lfile_name,curr_dir);
	}
else{
	if (file_name[0]==0){
		/* where are we? */
		if ((getcwd(dir_sel,126)!=NULL)&&(curr_dir[0]==0)){
			if(is_this_dir(dir_sel)==0)
			 strcpy(curr_dir,dir_sel);
			/* add a '/' */
			strcat(curr_dir,"/");
			};
		strcpy(lfile_name,curr_dir);
		}
	else strcpy(lfile_name,file_name);
	rfrsh_cmd(lfile_name);
	};
	/* call try_cmplt as it looks not to work at the first call !?!*/
try_cmplt(curr_dir, "a");
	/* get kb input char by char */
while((ch=getch())!=10){
	if (ch==KEY_BACKSPACE){ // bckspace
		lfile_name[strlen(lfile_name)-1]=0;
		}
	else if(ch==KEY_TAB){ // try a completion
		if (is_this_dir(curr_dir)==0){
			if((r=try_cmplt(curr_dir, &lfile_name[strlen(curr_dir)]))>0){
				strcpy(dir_sel, curr_dir);
				strcat(dir_sel, str);
				strcpy(lfile_name,dir_sel);
				}
			else bip();
			};
		}
	// care for utf8 ...
	else if(19 < ch && ch < 128){
		c=ch;
		l=strlen(lfile_name);
		lfile_name[l]=c;
		lfile_name[l+1]=0;
		}
	else if(ch > 127){
		if (utf_8==1){
			c=ch;
			l=strlen(lfile_name);
			lfile_name[l]=c;
			lfile_name[l+1]=0;
			c = getch();
			l=strlen(lfile_name);
			lfile_name[l]=c;
			lfile_name[l+1]=0;
			}	
		else{
			c=ch;
			l=strlen(lfile_name);
			lfile_name[l]=c;
			lfile_name[l+1]=0;
			}
		};
	// adjust curr_dir
	l=strlen(lfile_name);
	if (lfile_name[l-1]=='/')strcpy(curr_dir,lfile_name);
	else{ // find the last '/'
		strcpy(dir_sel,lfile_name);
		while(dir_sel[l]!='/')l--;
		dir_sel[l+1]=0;
		strcpy(curr_dir,dir_sel);
		};
	rfrsh_cmd(lfile_name);
	};
if (req==0){
	if (is_this_file(lfile_name)==0)
		strcpy(file_name,lfile_name);
	}
else strcpy(file_name,lfile_name);
noecho(); 
}
